package WebService::ForecastIo::DataPoint;
use Moo;
use namespace::autoclean;
use Types::DateTime 'DateTimeT';
use Types::Standard -all;

has [qw( time
         sunriseTime sunsetTime
         precipIntensityMaxTime
         temperatureMinTime temperatureMaxTime )] => (
    is => 'ro',
    isa => DateTimeT,
    coerce => DateTimeT->coercion,
);

has [qw(summary icon precipType)] => (
    is => 'ro',
    isa => Str,
);

has [qw( precipIntensity precipIntensityMax
         precipProbability precipAccumulation
         temperature temperatureMin temperatureMax
         dewPoint humidity
         windSpeed windBearing
         cloudCover
         pressure visibility ozone )] => (
    is => 'ro',
    isa => Num,
);

1;
