package WebService::TFL::Bus::Types;
use Type::Library -base, -declare => 'DateTimeMillis';
use Types::Standard -all;
use Type::Utils -all;
use Types::DateTime 'DateTimeT';
use namespace::autoclean;

declare DateTimeMillis, as DateTimeT;
coerce DateTimeMillis, from Num, via {
    require DateTime;
    DateTime->from_epoch( epoch => $_ / 1000 )
};

1;
